﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Public Class Form1
   Private moShapefile1 As ShapeFileFeatureLayer
   Private moNewBoundary As LineShape
   Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
      Me.WindowState = FormWindowState.Maximized
      Map1.MapUnit = GeographyUnit.Meter

      mAddShapefile(Map1, moShapefile1)
      ZoomToFeature("202042")

   End Sub
   Private Sub ZoomToFeature(sNumber As String)
      moShapefile1.Open()
      Dim oFeature As Feature = moShapefile1.QueryTools.GetFeaturesByColumnValue("StandNumbe", sNumber, ReturningColumnsType.AllColumns)(0)
      Map1.CurrentExtent = oFeature.GetBoundingBox
      moShapefile1.Close()

      Try
         Map1.Refresh()
      Catch ex As Exception
         MessageBox.Show("Error: " + ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
      End Try

   End Sub
   Private Sub mAddShapefile(oMap As WinformsMap, ByRef oShapefile As ShapeFileFeatureLayer)
      Dim sPath As String = "..\..\Data\TestLayer.shp"
      Dim oOverlay As New LayerOverlay

      If IO.File.Exists("..\..\Data\TestLayer.shp") Then
         sPath = "..\..\Data\TestLayer.shp"
      Else
         sPath = "Data\TestLayer.shp"
      End If

      Dim oProj4 As New ManagedProj4Projection(
                        ManagedProj4Projection.GetEsriParametersString(102003),
                        ManagedProj4Projection.GetGoogleMapParametersString)

      oShapefile = New ShapeFileFeatureLayer(sPath, ShapeFileReadWriteMode.ReadOnly)
      oShapefile.FeatureSource.Projection = oProj4

      Dim oAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue)
      Dim oTextStyle As New TextStyle("StandNumbe", New GeoFont("Arial", 10, DrawingFontStyles.Regular), New GeoSolidBrush(GeoColor.SimpleColors.Black))

      '***** This property causes the problem when layer is projected to Google projection
      oTextStyle.FittingPolygonInScreen = True

      oShapefile.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = oAreaStyle
      oShapefile.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = oTextStyle
      oShapefile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

      oOverlay.Layers.Add(oShapefile.Name, oShapefile)

      oMap.Overlays.Add(oOverlay)
   End Sub

   Private Sub btnZoomToError_Click(sender As Object, e As EventArgs) Handles btnZoomToError.Click
      ZoomToFeature("202009")
   End Sub
End Class
